package com.example.ReceiveItem.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.*;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;

@ToString
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(of={"id","name"})
@Data
@Document(value = "items")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class Item {
    @Id
    @JsonProperty(value = "id")
    private Integer id;

    @JsonProperty(value = "name")
    private String name;

    @JsonProperty(value = "quantity")
    private Long quantity;

    @JsonProperty(value = "price")
    private Double price;
}

