package com.example.ReceiveItem.service;


import com.example.ReceiveItem.entity.Item;
import com.example.ReceiveItem.producer.MessageProducer;
import com.example.ReceiveItem.repository.ItemRepository;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import reactor.core.publisher.Mono;

@Service
@Slf4j
@RequiredArgsConstructor
@Transactional
public class ItemService {

    @Autowired
    private ItemRepository itemRepository;

    @Autowired
    private MessageProducer messageProducer;


    public Mono<Item> receiveItem(Item item) {
        try {
            ObjectMapper objectMapper = new ObjectMapper();
            messageProducer.publishItem(objectMapper.writeValueAsString(item));
        } catch(JsonProcessingException e) {
            log.error("Caught Exception {}:: ",e);
        }
        return Mono.just(item);
    }

    public void saveItem(String item) {
        try {
            ObjectMapper mapper = new ObjectMapper();
            Item item1 = mapper.readValue(item,Item.class);
            itemRepository.save(item1).subscribe();
        } catch(JsonProcessingException e) {
            log.error("Caught Exception :: {} ",e);
        }
    }
}
